// ==UserScript==
// @name          マイサイトハイライトツール chika3号 Yahoo! JAPAN版
// @description	  Yahoo! JAPANの検索結果で自分のサイトをハイライト表示
// @include       http://search.yahoo.co.jp*
// @grant         none
// @icon          http://seopack.jp/muryouseotools/chika-a-32.png
// ==/UserScript==


(function() {
	
	//LS_deleteItem('chika_mysite');
	
	var hl_color = '#F6E3CE';
	//var hl_color = '#F3F781';
	
	var mysite;
	var editwindow;
	
	function LS_getItem(key) {
		return window.localStorage.getItem(key);
	}
	
	function LS_setItem(key, value) {
		if(value == null || value.length == 0) {
			LS_deleteItem(key);
		} else {
			return window.localStorage.setItem(key, value);
		}
	}
	
	function LS_deleteItem(key) {
		window.localStorage.removeItem(key);
	}
	
	var deleteMysite = function(address) {
		mysite.splice(address, 1);
		LS_setItem('chika_mysite', JSON.stringify(mysite));
		trNode = editwindow.document.getElementById('tr_' + address);
		trNode.parentNode.removeChild(trNode);
		editMysite();
	}
	
	editMysite = function() {
		editwindow = window.open('','input','width=400px,height=400px,location=no');
		
		var dt = '<p style="margin-bottom:10px;"><strong>登録済マイサイト一覧</strong></p><table id="edit_table" border="1" style="border-collapse:collapse;"><tbody id="edit_table_body"><tr><th width="250">ドメイン</th><th>削除</th></tr>';
		if(mysite != null && mysite.length >= 0) {
			for( var i = 0; i < mysite.length; i++) {
				dt += '<tr id="tr_' + i + '"><td>' + mysite[i] + '</td><td><input id="delete_' + i + '" type="button" value="削除" /></tr>';
			}
		}
		dt += '</tbody></table>';
		dt += '<p style="margin-bottom:8px;"><strong>新規マイサイト登録</strong></p><input type="text" id="add_mysite" name="add_mysite" size="35" /><input id="add_button" type="button" value="追加" />';
		dt += '<div style="margin-top:50px;float:right;"><input type="button" onclick="window.close()" value="このウィンドウを閉じる" /></div>';
		dt += '<div style="clear:both;"></div>';
		dt += '<div style="margin-top:50px;">';
		dt += '<p><small>もっと便利にSEO！ <a href="http://seopack.jp/muryouseotools/" target="_blank">SEO Packの無料SEOツール</a></small></p>';
		dt += '<p><small>powerd by <a href="http://devo.jp/" target="_blank">Devo</a> inc</p></div>';
		
		editwindow.document.body.innerHTML = dt;
		
		//イベント
		if(mysite != null && mysite.length >= 0) {
			for( var i = 0; i < mysite.length; i++) {
				var eb = editwindow.document.getElementById('delete_' + i);
				eb.onclick = (function(i_) {
					return function() { deleteMysite(i_) };
				})(i);
			}
		}
		
		var ab = editwindow.document.getElementById('add_button');
		ab.onclick = function() {
			var ms = editwindow.document.getElementById('add_mysite').value;
			mysite.push(ms);
			LS_setItem('chika_mysite', JSON.stringify(mysite));
			findMysite(mysite);
			
			var rc = editwindow.document.getElementsByTagName('tr').length;
			var nr = document.createElement('tr');
			nr.id = 'tr_' + (rc - 1);
			nr.innerHTML = '<td>' + ms + '</td>';
			nr.innerHTML += '<td><input id="delete_' + (rc - 1) + '" type="button" value="削除" /></td>';
			editwindow.document.getElementById('edit_table_body').appendChild(nr);
			
			eb = editwindow.document.getElementById('delete_' + (rc - 1));
			eb.onclick = (function(i_) {
				return function() { deleteMysite(i_) };
			})(rc - 1);
		}
	}
	
	function findMysite(mysite) {
		if(mysite != null || mysite.length != 0) {
			
			sw = document.getElementById('WS2m');
			ss = sw.getElementsByClassName('hd');
			
			for(var i = 0; i < mysite.length; i++) {
				for(var si = 0; si < ss.length; si++) {
					sp = ss[si].parentNode;
					sa = sp.querySelector('div h3 a');
					if(sa.href.indexOf(mysite[i]) >= 0) {
						sp.style.backgroundColor = hl_color;
					}
				}
			}
		}
	}
	
	function main() {
		
		mysite = LS_getItem('chika_mysite');
		if(mysite == null || mysite.length == 0) {
			mysite = [];
			var input_text = window.prompt('chika3号のご利用ありがとうございます。\nハイライトしたいサイトのドメインを入力してください。\n（例：サイトURLが http://seopack.jp なら、ドメインは seopack.jp になります）', 'seopack.jp');
			if(input_text != null && input_text.length > 0) {
				mysite.push(input_text);
				LS_setItem('chika_mysite', JSON.stringify(mysite));
			}
			//↓テスト用
			//mysite.push('devo.jp');
			//mysite.push('example.com');
			//↑テスト用
			
		} else {
			
			mysite = JSON.parse(mysite);
			//mysite = mysite.split(',');
		}
		//var SaC_elem = document.getElementById('SaC');
		//var SaC_elem = document.getElementById('SaA-dtl');
		//var SaC_elem = document.getElementsByClassName('SaA-dtl');
		var SaC_elem = document.querySelector('div.gLnk ul.lnk');
		var edit_elem = document.createElement('li');
		edit_elem.innerHTML = '<a href="#" /><img height="13px" style="display:line;" src="http://seopack.jp/muryouseotools/chika-a-32.png" />ハイライトするサイトを編集</a>';
		//edit_elem.setAttribute('class', 'inner');
		//edit_elem.style.paddingLeft = '39px';
		edit_elem.style.fontsize = '9px';
		edit_elem.onclick = editMysite;
		SaC_elem.appendChild(edit_elem);
		
		findMysite(mysite);
	}
	
	main();
	
	
})();